// multiwav.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "multiwav.h"
#include "multiwavDlg.h"
#include "sys\stat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMultiwavApp

BEGIN_MESSAGE_MAP(CMultiwavApp, CWinApp)
	//{{AFX_MSG_MAP(CMultiwavApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiwavApp construction

CMultiwavApp::CMultiwavApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMultiwavApp object

CMultiwavApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMultiwavApp initialization

BOOL CMultiwavApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif


	m_bProcessing=m_bAbort=m_bCLI=false;

	CMultiwavDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}



int  CMultiwavApp::GetInputInfo( int nFile, CString csInputFile)
{
	FILE * in;
	int i;
	uchar mybuffer[10];
	struct  _stati64 statbuf;
	uchar header[100];


	in=fopen(csInputFile,"rb");

	if (in==NULL)
	{
		AfxMessageBox("Error: Unable to open file",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}

// search for RIFF */
	for (i=0;!feof(in) && i < 12 ;i++)
		header[i]=fgetc(in);

	if (header[0] != 'R' || header[1] != 'I' || 
		header[2] != 'F' || header[3] != 'F' ||
		header[8] != 'W' || header[9] != 'A' || 
		header[10] != 'V' || header[11] != 'E' ) 
	{
		fclose(in);
		AfxMessageBox("Error: Something wrong in wav header.",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}

// search for fmt //

	fseek(in, 12, SEEK_SET);
	for (i=0;!feof(in) && i < 4 ;i++)
		mybuffer[i]=fgetc(in);
	m_iNextbyte[nFile]=16;

	while ((mybuffer[0] != 'f' || mybuffer[1] != 'm' || 
			mybuffer[2] != 't' || mybuffer[3] != ' ') && !feof(in))
	{
			fseek(in, -3L, SEEK_CUR);
			for (i=0;!feof(in) && i < 4 ;i++)
				mybuffer[i]=fgetc(in);
			m_iNextbyte[nFile]++;
	}
	if (mybuffer[0] != 'f' || mybuffer[1] != 'm' || 
		mybuffer[2] != 't' || mybuffer[3] != ' ') 
	{
		fclose(in);
		AfxMessageBox("Error: Something wrong in wav header.",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}

	fseek(in, -4L, SEEK_CUR);

	for (i=0;i<24;i++)
		header[12+i]=fgetc(in);
	m_iNextbyte[nFile]+=20;

// search for data //

	for (i=0;!feof(in) && i < 4 ;i++)
		mybuffer[i]=fgetc(in);
	m_iNextbyte[nFile]+=4;

	while ((mybuffer[0] != 'd' || mybuffer[1] != 'a' || 
			mybuffer[2] != 't' || mybuffer[3] != 'a') && !feof(in))
	{
			fseek(in, -3L, SEEK_CUR);
			for (i=0;!feof(in) && i < 4 ;i++)
				mybuffer[i]=fgetc(in);
			m_iNextbyte[nFile]++;
	}
	if (mybuffer[0] != 'd' || mybuffer[1] != 'a' || 
		mybuffer[2] != 't' || mybuffer[3] != 'a')
	{
		fclose(in);
		AfxMessageBox("Error: Something wrong in wav header.",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}

	fseek(in, -4L, SEEK_CUR);

	for (i=0;i<8;i++)
		header[24+12+i]=fgetc(in);

	m_iNextbyte[nFile]+=4;

	_fstati64 (fileno(in), &statbuf);

	m_iBytesPerSample[nFile]=	header[32]+header[33]*256;

	m_i64size[nFile]=	(UINT)(header[40]+(header[41]<<8)+(header[42]<<16)+(header[43]<<24));
	if (m_i64size[nFile] > statbuf.st_size-m_iNextbyte[nFile])
		m_i64size[nFile]= statbuf.st_size-m_iNextbyte[nFile];

//	m_nSamples=			(UINT)m_i64size/m_iBytesPerSample;
	m_iFsample[nFile]=		header[24]+(header[25]<<8)+(header[26]<<16)+(header[27]<<24);
	m_iByterate[nFile]=		header[28]+(header[29]<<8)+(header[30]<<16)+(header[31]<<24);
	m_nChannels[nFile]=		header[22]+(header[23]<<8);
	m_nBits[nFile]=			header[34]+(header[35]<<8);
//	m_iGrossRate=		(UINT)(m_iBytesPerSample*m_iFsample*8);
//	m_iActRate=			m_iByterate*8;

	fclose(in);
//bits_per_sample=		8 * bytes_per_second / sample_rate / channels
	
	m_nCalculatedBits[nFile]=m_iByterate[nFile]*8/m_iFsample[nFile]/m_nChannels[nFile];

	if (m_nCalculatedBits[nFile]!=m_nBits[nFile])
	{
		AfxMessageBox("Error: Something wrong in wav header or 20 bit format (unsupported).",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}
	if (m_iBytesPerSample[nFile]!=m_nChannels[nFile]*m_nBits[nFile]/8)
	{
		AfxMessageBox("Error: Something wrong in wav header or 20 bit format (unsupported).",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}

	if (nFile!=0 && ( m_nBits[nFile]!=m_nBits[0] ) )
	{
		AfxMessageBox("Error: This file has different number of bits.\nConvert it to the same number of bits.",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}
	if (nFile!=0 && ( m_iFsample[nFile]!=m_iFsample[0] ) )
	{
		AfxMessageBox("Error: This file has different sampling frecuency.\nConvert it to the same number of bits.",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}
	if (nFile==0 && ( m_nBits[0]!=8 && m_nBits[0]!=16 && m_nBits[0]!=24) )
	{
		AfxMessageBox("Error: Unsupported number of bits.",MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}
/*	
	m_nInputBits[nFile]=0;
	if (m_nCalculatedBits[nFile]==m_nBits[nFile])
	{
		if (m_nBits[nFile]==8) m_nInputBits=B8;
		else if  (m_nBits[nFile]==16) m_nInputBits=B16;
		else if  (m_nBits[nFile]==20) m_nInputBits=B20C;
		else if  (m_nBits[nFile]==24) m_nInputBits=B24;
	}
	else 
	{
		if (m_nBits==20 &&  m_nCalculatedBits==24) m_nInputBits=B20;
	}

	if (m_nInputBits==0) return 0;
*/
	if (nFile==0)
		for (i=0;i<100;i++)
			m_header[i]=header[i];

	return 1;
}

void  CMultiwavApp::ClearAll()
{
	int i,j;

	for (i=0; i<MAXCHAN;i++)
	{
		for (j=0; j <100; j++)
			m_header[100]=0;
		m_iNextbyte[i]=0;
		m_iBytesPerSample[i]=0;
		m_i64size[i]=0;
		m_iFsample[i]=0;
		m_iByterate[i]=0;
		m_nChannels[i]=0;
		m_nCalculatedBits[i]=0;
		m_nBits[i]=0;
		m_csInputFile[i]="";
	}
	m_csOutputFile="";
}

int CMultiwavApp::ExeDeILV(CWnd* pWnd)
{
	FILE* out[MAXCHAN];
	FILE* in;
	CString csAux;
	int  i,j,k,nChan;
	int nBytes,nRead;
	uchar bufferIn[SAMPLESATTIME*MAXCHAN*3];
	uchar bufferOut[MAXCHAN][SAMPLESATTIME*3];
	int nOutBytesPerSample;
	__int64 i64,i64BytesOfData;

	in=fopen(m_csInputFile[0],"rb");
	nChan=m_nChannels[0];

	fseek ( in,(long)m_iNextbyte[0], SEEK_SET);
	
	if (in==NULL) 
	{
		AfxMessageBox("Error: Unable to open input file" + m_csInputFile[0],MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}

	for (i=0;i<nChan;i++)
	{
		csAux.Format(_T("_%d.wav"),i);
		m_csOut[i]=m_csOutputFile.Left(m_csOutputFile.ReverseFind('.'))+csAux;
		out[i]=fopen(m_csOut[i],"wb");

		if (out[i]==NULL) 
		{
			AfxMessageBox("Error: Unable to open output file" + m_csOut[i],MB_OK |MB_ICONEXCLAMATION,0);
			for (j=0;j<i;j++)
				fclose (out[j]);
			fclose(in);
			return 0;
		}
		WriteHeader(out[i], 1);
	}

	nOutBytesPerSample=m_iBytesPerSample[0]/nChan;

	for (i64=i64BytesOfData=0; i64<m_i64size[0] && m_bAbort==false;  )
	{
		nBytes=m_iBytesPerSample[0];
		if ( (m_i64size[0]-i64) > m_iBytesPerSample[0]*SAMPLESATTIME)
			nBytes=m_iBytesPerSample[0]*SAMPLESATTIME;

		if (m_bCLI == false) 
			UpdateProgress(pWnd, (int)(i64*100/m_i64size[0]));

		nRead=fread(bufferIn,sizeof (unsigned char),nBytes,in);
		if (nRead!=nBytes) 
			break;

		for (i=0;i< nRead;i+=m_iBytesPerSample[0])
		{
			for (j=0;j<nChan;j++)
			{
				for (k=0;k<nOutBytesPerSample;k++)
					bufferOut[j][i/nChan+k]=bufferIn[i+j*nOutBytesPerSample+k];
			}
		}

		for (i=0;i<nChan;i++)
			fwrite(bufferOut[i],sizeof (unsigned char), nRead/nChan , out[i]);

		i64+= (__int64)nBytes;
		i64BytesOfData+=(__int64)(nRead/nChan);

	}

	fclose(in);

	for (i=0;i<nChan;i++)
	{
		WriteSize(out[i] , i64BytesOfData);
		fclose(out[i]);
	}
	return 1;
}

void CMultiwavApp::WriteHeader(FILE * out, int nChan)
{

	int i;
	uchar bufferOut[50];
	int ByteRate,BlockAlign;

	for (i=0;i<44;i++)
	{
		bufferOut[i]=m_header[i];
	}

//	# of channels (22-23)
	bufferOut[22]=(uchar)nChan;
	bufferOut[23]=(uchar)0;

//	Sample rate (24-27: Do not change)
//	Byte rate ( 4 bytes)== SampleRate * NumChannels * BitsPerSample/8
	ByteRate= m_iFsample[0]*nChan*m_nBits[0]/8;
	bufferOut[28]=(uchar)( ByteRate     %256);
	bufferOut[29]=(uchar)((ByteRate>>8 ) %256);
	bufferOut[30]=(uchar)((ByteRate>>16) %256);
	bufferOut[31]=(uchar)((ByteRate>>24) %256);

//	Block align ( 2 bytes)== NumChannels * BitsPerSample/8
	BlockAlign= nChan*m_nBits[0]/8;
	bufferOut[32]=(uchar)( BlockAlign     %256);
	bufferOut[33]=(uchar)((BlockAlign>>8) %256);

//	Bits per sample ( 2 bytes)
	bufferOut[34]=(uchar)m_nBits[0];
	bufferOut[35]=0;

	fwrite(bufferOut,sizeof (unsigned char), 44 , out);

}

void  CMultiwavApp::WriteSize(FILE * out, __int64 i64BytesOfData)
{
// Rewrite in header length chunk & data subchunk

	__int64 i64Aux;

	fseek ( out,(long)4, SEEK_SET);
	i64Aux=36+i64BytesOfData;
	fputc((unsigned char)(i64Aux%256),out);
	fputc((unsigned char)((i64Aux >> 8)%256),out);
	fputc((unsigned char)((i64Aux >>16)%256),out);
	fputc((unsigned char)((i64Aux >>24)%256),out);

	fseek ( out,(long)40, SEEK_SET);
	i64Aux=i64BytesOfData;
	fputc((unsigned char)(i64Aux%256),out);
	fputc((unsigned char)((i64Aux >> 8)%256),out);
	fputc((unsigned char)((i64Aux >>16)%256),out);
	fputc((unsigned char)((i64Aux >>24)%256),out);

}

int CMultiwavApp::ExeILV(int nChan , CWnd* pWnd )
{

	FILE* in[MAXCHAN];
	FILE* out;
	CString csAux;
	int  i,j,k;
	int nBytes,nRead, nBPS;
	uchar bufferOut[SAMPLESATTIME*MAXCHAN*3];
	uchar bufferIn[MAXCHAN][SAMPLESATTIME*3];
	int nOutBytesPerSample;
	__int64 i64,i64BytesOfData,i64size;
	uchar uZero;


	out=fopen(m_csOutputFile,"wb");
	if (out==NULL) 
	{
		AfxMessageBox("Error: Unable to open output file" + m_csOutputFile,MB_OK |MB_ICONEXCLAMATION,0);
		return 0;
	}
	WriteHeader(out, nChan);

	i64size=0;
	for (i=0;i<nChan;i++)
		if (m_i64size[i]>i64size) i64size=m_i64size[i];
	
	for (i=0;i<nChan;i++)
	{
		in[i]=fopen(m_csInputFile[i],"rb");

		if (in[i]==NULL) 
		{
			AfxMessageBox("Error: Unable to open input file" + m_csInputFile[i],MB_OK |MB_ICONEXCLAMATION,0);
			for (j=0;j<i;j++)
				fclose (in[j]);
			fclose (out);
			return 0;
		}
		fseek ( in[i],(long)m_iNextbyte[i], SEEK_SET);
	}

	nOutBytesPerSample=m_iBytesPerSample[0]/nChan;

	uZero=0;
	if (m_nBits[0]==8)
		uZero=0x80;

	nBPS=m_iBytesPerSample[0];

	for (i64=i64BytesOfData=0; i64<i64size && m_bAbort==false;  )
	{
		nBytes=nBPS;
		if ( (i64size-i64) > nBPS*SAMPLESATTIME)
			nBytes=nBPS*SAMPLESATTIME;

		if (m_bCLI == false) 
			UpdateProgress(pWnd, (int)(i64*100/i64size));

		for (i=0;i<nChan;i++)
		{
			nRead=fread(bufferIn[i],sizeof (unsigned char),nBytes,in[i]);
			for (j=nRead; j<nBytes; j++)
				bufferIn[i][j]=uZero;	
		}


		for (i=0;i< nBytes;i+=nBPS)
		{
			for (j=0;j<nChan;j++)
			{
				for (k=0;k<nBPS;k++)
					bufferOut[i*nChan+j*nBPS+k]=bufferIn[j][i+k];
			}
		}


		fwrite(bufferOut,sizeof (unsigned char), nBytes*nChan , out);

		i64+= (__int64)nBytes;
		i64BytesOfData+=(__int64)(nRead*nChan);

	}


	for (i=0;i<nChan;i++)
		fclose(in[i]);

	WriteSize(out , i64BytesOfData);
	fclose(out);

	return 1;
}

void CMultiwavApp::UpdateProgress( CWnd* pDlg, int nPerc)
{
	MSG msg;
	static int oldPerc=-1;
	static int calls=0;

// Just to improve the performance
	calls++;
	if ((calls%10) != 0 && nPerc !=100) return;


	if ( pDlg )
	{
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (oldPerc!=nPerc) 
		{
			((CMultiwavDlg *)pDlg)->UpdateProgress(nPerc);
			oldPerc=nPerc;
		}
	}

}