// multiwav.h : main header file for the MULTIWAV application
//

#if !defined(AFX_MULTIWAV_H__7CB9EE8D_507F_4BC5_A33A_02CF0062F0ED__INCLUDED_)
#define AFX_MULTIWAV_H__7CB9EE8D_507F_4BC5_A33A_02CF0062F0ED__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

typedef unsigned char uchar;

#define MAXCHAN 16
#define SAMPLESATTIME 256


/////////////////////////////////////////////////////////////////////////////
// CMultiwavApp:
// See multiwav.cpp for the implementation of this class
//

class CMultiwavApp : public CWinApp
{
public:
	CMultiwavApp();
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMultiwavApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CMultiwavApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG

public:
	virtual int GetInputInfo( int nFile, CString csInputFile);
	virtual void ClearAll();
	virtual int ExeDeILV(CWnd* pWnd);
	virtual int ExeILV(int nChan , CWnd* pWnd );
	virtual void WriteHeader(FILE * out, int nChan);
	virtual void WriteSize(FILE * out, __int64 i64BytesOfData);
	virtual void UpdateProgress( CWnd* pDlg, int nPerc);



	DECLARE_MESSAGE_MAP()
// Members
public:
	bool	m_bCLI, m_bAbort, m_bProcessing;

	uchar	m_header[100];	// stores the wave header
	UINT	m_iNextbyte[MAXCHAN];		// points where pcm data starts in input file
	UINT	m_iBytesPerSample[MAXCHAN];
	__int64	m_i64size[MAXCHAN];		// size of Input data;
	UINT	m_iFsample[MAXCHAN],m_iByterate[MAXCHAN];
	UINT	m_nChannels[MAXCHAN];
	UINT	m_nCalculatedBits[MAXCHAN];	// Calculated bits 
	UINT	m_nBits[MAXCHAN];		// Data read from header
//	UINT	m_nInputBits;  //INTERNAL B16,B20,B20C,B24
//	UINT	m_nOutputBits; //INTERNAL B16,B20,B20C,B24
//	UINT	m_iGrossRate,m_iActRate; 
	CString m_csInputFile[MAXCHAN], m_csOutputFile;
	CString m_csOut[MAXCHAN];

};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTIWAV_H__7CB9EE8D_507F_4BC5_A33A_02CF0062F0ED__INCLUDED_)
